<?php

////////////////////////////////////////////////////////////////////////
///
///                 Configuration
///
////////////////////////////////////////////////////////////////////////

require_once ('../../../wp-config.php');

define('GSOM_SS_SUBSCRIBED',0);
define('GSOM_SS_CONFIRMED',1);
define('GSOM_SS_UNSUBSCRIBED',2);

////////////////////////////////////////////////////////////////////////
///
///                 Functions
///
////////////////////////////////////////////////////////////////////////

$responce = array();

function jsonresponce($state,$mess)
{
global $responce;
global $db;
//if ($state == "false") logerror($mess);

header("Content-type: application/json");

$responce['state'] = $state;
$responce['msg'] = $mess;

echo json_encode($responce);
//echo "<pre>";
//print_r(var_dump($responce),true);
//echo "</pre>";    
   
if ($db) $db->close();  
exit();
}

function RequestPresent($param)
{
    if (!isset($_REQUEST[$param]))
    {
        if(func_num_args() == 2)
        {
            $def = func_get_arg(1);
            global ${$param};
            ${$param} = $def;
        }
        else
            jsonresponce('false','required parameter "'.$param.'" is missing in request');
    }
    else
    {
        global ${$param};
        ${$param} = $_REQUEST[$param];
    }
}

////////////////////////////////////////////////////////////////////////
///
///                 Code
///
////////////////////////////////////////////////////////////////////////

//$db = new SQL(false,DB_HOST,DB_USER,DB_PASSWORD,DB_NAME);


// admin.php require a proper login cookie
require_once(ABSPATH . '/wp-admin/admin.php');

//check for correct capability
if ( !is_user_logged_in() )
   jsonresponce('false','Login Failure');    
   
   

//check for correct capability
if ( !current_user_can('level_10') ) 
    jsonresponce('false','You do not have admin rights.');
    
RequestPresent('page','1');
RequestPresent('ipp','25');
RequestPresent('email','');
RequestPresent('show','all');
RequestPresent('q',false);


global $wpdb;

$gsom_table_subs = $wpdb->prefix . "gsom_subscribers";

$pos_from = ($page-1)*$ipp;
$pos_to = $ipp;

switch($show)
{
    case 'all':
        $sel = '';
    break;
    case 'confirmed':
        $sel = 'WHERE intStatus = '.GSOM_SS_CONFIRMED;
    break;
    case 'unconfirmed':
        $sel = 'WHERE intStatus = '.GSOM_SS_SUBSCRIBED;
    break;    
    case 'unsubscribed':
        $sel = 'WHERE intStatus = '.GSOM_SS_UNSUBSCRIBED;
    break;    
}



if ($q == false) // if not search request
{   
    $cntres = $wpdb->get_results($wpdb->prepare('SELECT COUNT(intId) as cnt, intStatus FROM '.$gsom_table_subs.' group BY intStatus'),ARRAY_A);

    $cnt_all = 0;

    $responce['count'] = array();
    if (($cntres) && (!empty($cntres)))
    {
        foreach($cntres as $item)
        {
            switch($item['intStatus'])
            {
                case GSOM_SS_CONFIRMED:
                    $responce['count']['confirmed'] = $item['cnt'];
                break;
                case GSOM_SS_SUBSCRIBED:
                    $responce['count']['unconfirmed'] = $item['cnt'];
                break;
                case GSOM_SS_UNSUBSCRIBED:
                    $responce['count']['unsubscribed'] = $item['cnt'];
                break;        
            }    
            $cnt_all += $item['cnt'];
        }
    }
    else
    {
        $responce['count']['confirmed'] = $item['cnt'];
        $responce['count']['unconfirmed'] = $item['cnt'];
        $responce['count']['unsubscribed'] = $item['cnt'];
    }

    $responce['count']['all'] = $cnt_all;    
    
    switch($show)
    {
        case 'all':
            $cnt = $responce['count']['all'];
        break;
        case 'confirmed':
            $cnt = $responce['count']['confirmed'];
        break;
        case 'unconfirmed':
            $cnt = $responce['count']['unconfirmed'];
        break;    
        case 'unsubscribed':
            $cnt = $responce['count']['unsubscribed'];
        break;    
    }

    if(($cnt < 1) || ($ipp < 1))        
        $responce['pageCount'] = 1;
    else
        $responce['pageCount'] = ceil($cnt / $ipp);

    $sql = $wpdb->prepare('SELECT * FROM '.$gsom_table_subs.' '.$sel.' ORDER BY intId DESC LIMIT %d, %d',$pos_from,$pos_to);
}
else // if search request
{
    $sql = $wpdb->prepare('SELECT COUNT(intId) as cnt, intStatus FROM '.$gsom_table_subs.' WHERE varEmail regexp %s group BY intStatus',preg_quote($q));
    //echo $sql;
    
    $cntres = $wpdb->get_results($sql,ARRAY_A);

    $cnt_all = 0;

    $responce['count'] = array();

    foreach($cntres as $item)
    {
        switch($item['intStatus'])
        {
            case GSOM_SS_CONFIRMED:
                $responce['count']['confirmed'] = $item['cnt'];
            break;
            case GSOM_SS_SUBSCRIBED:
                $responce['count']['unconfirmed'] = $item['cnt'];
            break;
            case GSOM_SS_UNSUBSCRIBED:
                $responce['count']['unsubscribed'] = $item['cnt'];
            break;        
        }    
        $cnt_all += $item['cnt'];
    }

    $responce['count']['all'] = $cnt_all;    
    
    switch($show)
    {
        case 'all':
            $cnt = $responce['count']['all'];
        break;
        case 'confirmed':
            $cnt = $responce['count']['confirmed'];
        break;
        case 'unconfirmed':
            $cnt = $responce['count']['unconfirmed'];
        break;    
        case 'unsubscribed':
            $cnt = $responce['count']['unsubscribed'];
        break;    
    }

    if(($cnt < 1) || ($ipp < 1))        
        $responce['pageCount'] = 1;
    else
        $responce['pageCount'] = ceil($cnt / $ipp);
        
    if (trim($sel) == '')
    {
        $sel .= 'WHERE varEmail regexp %s';
    }
    else
    {
        $sel .= ' AND varEmail regexp %s';
    }
        
    $sql = $wpdb->prepare('SELECT * FROM '.$gsom_table_subs.' '.$sel.' ORDER BY intId DESC LIMIT %d, %d',preg_quote($q),$pos_from,$pos_to);   
    
   // echo $sql;
        
}

    
$result = $wpdb->get_results($sql,ARRAY_A);

$responce['rows'] = array();

if (($result !== false) && is_array($result) && !empty($result))
{
    foreach ($result as $row)
    {
        $responce['rows'][] = array('id' => $row['intId'],
                                    'time' => $row['dtTime'],
                                    'ip' => $row['varIP'],
                                    'email' => $row['varEmail'],
                                    'customData' => $row['textCustomFields'],
                                    'status' => $row['intStatus']);
    }
}

if (function_exists('get_option'))
{
    $responce['url'] = get_option('siteurl');
    jsonresponce('true','success');
}
else    
    jsonresponce('false','no get option');        


?>
