<?php

////////////////////////////////////////////////////////////////////////
///
///                 Configuration
///
////////////////////////////////////////////////////////////////////////

require_once ('../../../wp-config.php');

define('GSOM_SS_SUBSCRIBED',0);
define('GSOM_SS_CONFIRMED',1);
define('GSOM_SS_UNSUBSCRIBED',2);



////////////////////////////////////////////////////////////////////////
///
///                 Functions
///
////////////////////////////////////////////////////////////////////////

$responce = array();

function jsonresponce($state,$mess)
{
global $responce;
global $db;
//if ($state == "false") logerror($mess);

header("Content-type: application/json");

$responce['state'] = $state;
$responce['msg'] = $mess;

echo json_encode($responce);
//echo "<pre>";
//print_r(var_dump($responce),true);
//echo "</pre>";    
   
if ($db) $db->close();  
exit();
}

function RequestPresent($param)
{
    if (!isset($_REQUEST[$param]))
    {
        if(func_num_args() == 2)
        {
            $def = func_get_arg(1);
            global ${$param};
            ${$param} = $def;
        }
        else
            jsonresponce('false','required parameter "'.$param.'" is missing in request');
    }
    else
    {
        global ${$param};
        ${$param} = $_REQUEST[$param];
    }
}

function StatusCodeToText($code)
{
    switch ($code)
    {
        case GSOM_SS_CONFIRMED:
            return 'Confirmed';
        break;
        case GSOM_SS_SUBSCRIBED:
            return 'Unconfirmed';
        break;
        case GSOM_SS_UNSUBSCRIBED:
            return 'unsubscribed';
        break;
    }
}

// export functions

function toExcel($results)
{
    
    $title = 'subscribers';
        
    //XML Blurb
    
$dataHead = "<?xml version='1.0'?>
<?mso-application progid='Excel.Sheet'?>
<Workbook xmlns='urn:schemas-microsoft-com:office:spreadsheet' xmlns:o='urn:schemas-microsoft-com:office:office' xmlns:x='urn:schemas-microsoft-com:office:excel' xmlns:ss='urn:schemas-microsoft-com:office:spreadsheet' xmlns:html='http://www.w3.org/TR/REC-html40'>
<Worksheet ss:Name='".$title."'>
<Table>";

$data = '';
$dataHeadFields = '';

$cf_sequence = array(); // the array of custom fields to keep the right sequence of the custom fields 
    
    if ((is_array($results)) && (!empty($results)))
    foreach($results as $item)
    {
        $data .= '<Row>';
        $data .= "<Cell><Data ss:Type='String'>".$item['varEmail']."</Data></Cell>";
        $data .= "<Cell><Data ss:Type='String'>".$item['varIP']."</Data></Cell>";
        $data .= "<Cell><Data ss:Type='String'>".$item['dtTime']."</Data></Cell>";
        $data .= "<Cell><Data ss:Type='String'>".StatusCodeToText($item['intStatus'])."</Data></Cell>";
        
        $jdform = CustomFormToAArray($item['textCustomFields']);
                
        if (is_array($jdform) && !empty($jdform))
        {
            // if sequence is not yet defined, define it from the first form
            if (empty($cf_sequence)) 
            {   
               $cf_sequence = array_keys($jdform);               
            }
            
            // loop thru defined fields first
            foreach($cf_sequence as $cItem)
            {                
                if (isset($jdform[$cItem]))
                    $data .= "<Cell><Data ss:Type='String'>".$jdform[$cItem]."</Data></Cell>";
                else
                    $data .= "<Cell><Data ss:Type='String'></Data></Cell>";
            }
            
            // loop thru the rest fields
            foreach($jdform as $key => $value)
            {                
                if (!in_array($key,$cf_sequence))
                {
                    $data .= "<Cell><Data ss:Type='String'>".$value."</Data></Cell>";
                    $cf_sequence[] = $key;
                }
            }
            
        }
        $data .= "</Row>";
    }
    
    
    // Combining field names head row
    $dataHeadFields = '<Row>';
    $dataHeadFields .= "<Cell><Data ss:Type='String'>Email</Data></Cell>";
    $dataHeadFields .= "<Cell><Data ss:Type='String'>IP Address</Data></Cell>";
    $dataHeadFields .= "<Cell><Data ss:Type='String'>Time</Data></Cell>";
    $dataHeadFields .= "<Cell><Data ss:Type='String'>Status</Data></Cell>";
    foreach ($cf_sequence as $item)    
        $dataHeadFields .= "<Cell><Data ss:Type='String'>".$item."</Data></Cell>";            
    $dataHeadFields .= "</Row>";    
     
    //Final XML Blurb
    $dataFooter .= "</Table></Worksheet></Workbook>";
    
    //header("Content-type: application/xml");
       
    header("Content-type: application/octet-stream");
    header("Content-Disposition: attachment; filename=$title.xls;");
    header("Content-Type: application/ms-excel");
    header("Pragma: no-cache");
    header("Expires: 0");

    echo $dataHead.$dataHeadFields.$data.$dataFooter;
}

function csvEscape($str,$delimiter)
{
    
    if (preg_match('/[\r\n'.preg_quote($delimiter).']+/i',$str))
        return '"'.$str.'"';
    else 
        return $str;
}

function toCSV($results,$delimiter)
{
    
    $title = 'subscribers';
       
$data = '';
$dataHeadFields = '';

$cf_sequence = array(); // the array of custom fields to keep the right sequence of the custom fields 
    
    if ((is_array($results)) && (!empty($results)))
    foreach($results as $item)
    {
        $data .=    csvEscape($item['varEmail'],$delimiter).$delimiter.
                    csvEscape($item['varIP'],$delimiter).$delimiter.
                    csvEscape($item['dtTime'],$delimiter).$delimiter.
                    csvEscape(StatusCodeToText($item['intStatus']),$delimiter).$delimiter;
        
        $jdform = CustomFormToAArray($item['textCustomFields']);
                
        if (is_array($jdform) && !empty($jdform))
        {
            // if sequence is not yet defined, define it from the first form
            if (empty($cf_sequence)) 
            {   
               $cf_sequence = array_keys($jdform);               
            }
            
            // loop thru defined fields first
            foreach($cf_sequence as $cItem)
            {                
                if (isset($jdform[$cItem]))
                    $data .= csvEscape($jdform[$cItem],$delimiter).$delimiter;
                else
                    $data .= $delimiter;
            }
            
            // loop thru the rest fields
            foreach($jdform as $key => $value)
            {                
                if (!in_array($key,$cf_sequence))
                {
                    $data .= csvEscape($value,$delimiter).$delimiter;
                    $cf_sequence[] = $key;
                }
            }
            
        }
        $data .= "\r\n";
    }
    
    
    // Combining field names head row    
    $dataHeadFields .= csvEscape('Email',$delimiter).$delimiter;
    $dataHeadFields .= csvEscape('IP Address',$delimiter).$delimiter;
    $dataHeadFields .= csvEscape('Time',$delimiter).$delimiter;
    $dataHeadFields .= csvEscape('Status',$delimiter).$delimiter;
    foreach ($cf_sequence as $item)    
        $dataHeadFields .= csvEscape($item,$delimiter).$delimiter;        
    $dataHeadFields .= "\r\n";    
     
    
    //header("Content-type: application/xml");
       

    header("Content-Disposition: attachment; filename=$title.csv;");
    header("Pragma: no-cache");
    header("Expires: 0");

    echo $dataHeadFields.$data;
}

function CustomFormToAArray($customForm)
{   
    $res = array(); 
    $jdform = json_decode($customForm,true);    
    
    foreach($jdform as $item)    
        $res[$item['label']] = $item['value'];    
    
    return $res;    
}

////////////////////////////////////////////////////////////////////////
///
///                 Code
///
////////////////////////////////////////////////////////////////////////

//$db = new SQL(false,DB_HOST,DB_USER,DB_PASSWORD,DB_NAME);


// admin.php require a proper login cookie
require_once(ABSPATH . '/wp-admin/admin.php');

//check for correct capability
if ( !is_user_logged_in() )
   jsonresponce('false','Login Failure');    

//check for correct capability
if ( !current_user_can('level_10') ) 
    jsonresponce('false','You do not have admin rights.');
    
$gsom_form = get_option('gsom_form');    
    
RequestPresent('type','all');
RequestPresent('to','xml');
RequestPresent('q',false);


global $wpdb;
$gsom_table_subs = $wpdb->prefix . "gsom_subscribers";

switch($type)
{
    case 'all':
        $sel = '';
    break;
    case 'confirmed':
        $sel = 'WHERE intStatus = '.GSOM_SS_CONFIRMED;
    break;
    case 'unconfirmed':
        $sel = 'WHERE intStatus = '.GSOM_SS_SUBSCRIBED;
    break;    
    case 'unsubscribed':
        $sel = 'WHERE intStatus = '.GSOM_SS_UNSUBSCRIBED;
    break;    
}

if ($q == false)
{
    $sql = $wpdb->prepare('SELECT * FROM '.$gsom_table_subs.' '.$sel.' ORDER BY intId DESC');
}
else
{
    if (trim($sel) == '')
    {
        $sel .= 'WHERE varEmail regexp %s';
    }
    else
    {
        $sel .= ' AND varEmail regexp %s';
    }
        
    $sql = $wpdb->prepare('SELECT * FROM '.$gsom_table_subs.' '.$sel.' ORDER BY intId DESC',preg_quote($q));
}
    
$result = $wpdb->get_results($sql,ARRAY_A);

switch($to)
{
    case 'csv':
        toCSV($result,',');
    break;
    case 'xml':
        toExcel($result);     
    break;
}




?>
