<?php
/*
Plugin Name: G-Lock Double Opt-in Manager
Plugin URI: http://www.glockeasymail.com/wordpress-email-newsletter-plugin-for-double-opt-in-subscription/
Description: This mailing list management plugin allows the visitors of your blog subscribe to your mailing list using a double opt-in method. The plugin sends an email with the subscription confirmation link to the user and if the user confirms the subscription, it sends a welcome email to each new subscriber. The details of new subscribers are saved to the internal WordPress database. You can <a target="_blank" href="http://www.glockeasymail.com/wordpress-email-newsletter-plugin-for-double-opt-in-subscription/">manage the mailing list inside WordPress</a> and export the list for the further use in your <a target="_blank" href="http://www.glockeasymail.com/downloads/">email newsletter sending program</a>.
Version: 1.0
Author: Alex Ladyga - G-Lock Software
Author URI: http://www.glocksoft.com
*/
/*  Copyright 2008  Alex Ladyga (email : alexladyga@glocksoft.com)
    Copyright 2008  G-Lock Software

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

$gsom_db_version = "1.0";
$gsom_def_form = '';           
$gsom_form = '';

$gsom_table_subs = $wpdb->prefix . "gsom_subscribers";

define('GSOM_SS_SUBSCRIBED',0);
define('GSOM_SS_CONFIRMED',1);
define('GSOM_SS_UNSUBSCRIBED',2);

$gsom_form_vars = array();
$gsom_form_vars['blog_name'] = get_option('blogname');            
$gsom_form_vars['blog_url'] = get_option('siteurl');
$gsom_eml = get_option('gsom_email_from');
$gsom_frname = get_option('gsom_name_from');
$gsom_form_vars['from_email'] = (trim($gsom_eml) != '') ? $gsom_eml : get_option('admin_email');
$gsom_form_vars['from_name'] = (trim($gsom_frname) != '') ? $gsom_frname : get_option('blogname');

if(isset($_REQUEST['x']))
{
    $gsom_semail = gsom_ModBase64Decode($_REQUEST['x']);
    $gsom_form_vars['manage_subscription_link'] = gsom_GetUnsubscribeLink($gsom_semail);
    $gsom_form_vars['confirmation_link'] = gsom_GetConfirmationLink($gsom_semail);
    $gsom_form_vars['resend_confirmation_link'] = gsom_GetResendConfirmationLink($gsom_semail);    
    $gsom_form_vars['encoded_email'] = $_REQUEST['x'];
    $gsom_form_vars['decoded_email'] = $gsom_semail;
}


function gsom_install() {
    global $wpdb;
    global $gsom_db_version;    
    
    $gsom_table_subs = $wpdb->prefix . "gsom_subscribers";
    
    if($wpdb->get_var("show tables like '".$gsom_table_subs."'") != $gsom_table_subs) {    

        // Table did not exist; create new
        $sql = "CREATE TABLE ".$gsom_table_subs." (
                  `intId` int(10) unsigned NOT NULL auto_increment,
                  `dtTime` datetime NOT NULL,
                  `varIP` varchar(50) NOT NULL,
                  `varEmail` varchar(255) NOT NULL,
                  `textCustomFields` text NOT NULL,
                  `intStatus` tinyint(3) unsigned NOT NULL default '0',
                  PRIMARY KEY  (`intId`)
                )";
        $result = $wpdb->query($sql);
        //require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
        //dbDelta($sql);

        add_option("gsom_db_version", $gsom_db_version);

        // Initialise options with default values
        $blogname = get_option('blogname');
        add_option('gsom_form_title', 'Subscription');
        add_option('gsom_email_from', get_option('admin_email') );
        add_option('gsom_name_from', get_option('blogname') );
        
// ----- email confirmation         
        
        add_option('gsom_email_confirmation_subj','Please, confirm your request for information from $blog_url');        
        
        $msg = '
Hello $gsom-fname-field,

We received your request for information from $blog_name

Before we begin sending you the information you requested, we want to be certain we have your permission.

Click the link below to give us permission to send you information. It\'s fast and easy!  If you cannot click the full URL below, please copy the URL and paste it into your web browser.

CONFIRM BY CLICKING THIS URL:

$confirmation_link

If you do not want to subscribe, simply ignore this message.

Best Regards,
$blog_name
$blog_url


Request generated by:
IP: $subscriber_ip
Date: $subscription_time';
        add_option('gsom_email_confirmation_msg',$msg);
        
// ----- email welcome
        
        add_option('gsom_email_welcome_subj', 'Thank you for confirming your subscription at $blog_url');
        
        $msg = '
Dear $gsom-fname-field,

Thank you for your subscription. Your email address $gsom-email-field was added to our mailing list. We will keep your personal information private and secure. We will not share your email address with any third parties. To ensure the email delivery, please add $from_email to your e-mail address book or safe senders list.

Sincerely,
$from_name
$blog_url

You are receiving this email because on $subscription_time at $blog_url you subscribed to receive our e-newsletters.
                         
You can modify your subscription via the link below:
$manage_subscription_link';

        add_option('gsom_email_welcome_msg', $msg);
        
// ----- email unsubscribe        
        
        add_option('gsom_email_unsubscribe_subj','Removal Request Confirmation');        
        
        $msg = 'Dear $gsom-fname-field,

This email is being sent to notify you that we have received a request to remove the following record from our mailing list:

Name: $gsom-fname-field
Email: $gsom-email-field

This record was removed from our online database and will also be removed from any backup files shortly.

If you do receive further unwanted email from our system, please let us know using the contact information below and we\'d be happy to address the issue immediately.

Sincerely,
$from_name
$from_email
$blog_url';
        add_option('gsom_email_unsubscribe_msg',$msg);
        
// -----
        
    
        
        
        add_option('gsom_send_welcome_message', "1");
        add_option('gsom_send_unsubscibed_message', "1");
        
        $msg='<h2>Please Check Your Email to Confirm Your Subscription!</h2> <h3 style="color:#FF0000;">We sent you an email with a link to confirm your subscription. If you do not receive it within a reasonable amount of time, please check your spam filters to ensure you are allowing emails from $from_email.</h3><p> To ensure that our email reaches your Inbox, and is not deleted or moved to your Junk Mail folder, add our email address $from_email to your safe sender list by following the directions below. <p>If your email provider is not listed here, contact your email host and ask them how you can whitelist email addresses so you will get our special announcement and tip emails.</p> </p> <p><h3>Yahoo Mail</h3></p> <p>To create a filter that sends our emails to your Inbox:</p> <ol> <li>Login to Yahoo Mail.</li> <li>Click on "Mail Options" (on the right hand side of the screen).</li> <li>Click on "Filters" (on left hand side of the screen).</li> <li>Click "Add" button.</li> <li>Assign a name for this filter: "Newsletter Name".</li> <li>Underneath the heading "if all of the following rules are true..." go to the top row labeled "FROM header." Next to this you will see a drop down menu. Make sure to select "contains", then simply type in our email address $from_email into the box provided.</li> <li>At the bottom, where it says "Move the message to:", select "Inbox" from the drop-down menu.</li> <li>Click the "Add Filter" button at the bottom to add this filter.</li> </ol> <p style="margin-top: 20px; "> <h3>MSN Hotmail</h3></p> <p>To add our email address to your "Safe List":</p> <ol> <li>Login to your Hotmail or MSN Mail account.</li> <li>Click on "Options."</li> <li>Click "Junk Mail Protection".</li> <li>Click on "Safe List."</li> <li>In the box provided, type in our domain.</li> <li>Click the "Add" button.</li> <li>When you see the address you entered in the Safe List box, click on the "OK" button.</li> </ol> <p>To add our email address to your "Contacts List":</p> <ol> <li>Login to your Hotmail of MSN Mail account.</li> <li>Click on "Contacts" folder.</li> <li>In the new screen which opens, click "New" (upper left corner).</li> <li>Assign a Quickname in the left hand box.</li> <li>Enter our email address $from_email into the "Online Addresses" area.</li> </ol> <p style="margin-top: 20px; "> <h3>AOL Mail</h3></p> <p>To add our email address to your Address Book or Custom Sender List:</p> <p>AOL 9.0:</p> <ol> <li>Click the "Spam Controls" link (lower right area of your inbox).</li> <li>When the "Mail & Spam Controls" box appears, click "Custom sender list".</li> <li>Choose "allow email from" option</li> <li>Add the domain/email address you would like to receive mail from.</li> <li>Click "Add", then click "Save".</li> </ol> <p style="margin-top: 20px; ">AOL 7 & 8:</p> <ol> <li>Go to Keyword Mail Controls.</li> <li>Select the screen name you are using to receive email.</li> <li>Click "Customize Mail Controls For This Screen Name."</li> <li>Allow/Included</li> <ol style="padding-left: 18px;"> <li style="list-style-type: lower-alpha;">For AOL version 7.0: In the section for "exclusion and inclusion parameters", include the following domain: * @mysite.com</li> <li style="list-style-type: lower-alpha;">For AOL version 8.0: Select "Allow email from all AOL members, email addresses and domains."</li> </ol> <li>Click on "Next" until the "Save" button shows up at the bottom.</li> <li>Click "Save."</li> </ol> <p style="margin-top: 20px; "> <h3>Outlook 2003 Mail</h3></p> <p>To make sure you can see emails as they were intended to be seen (including images), add our email address $from_email to your address book and safe sender list.</p> <p>To add our email address to your address book:</p> <ol> <li>Right click on the email subject line.</li> <li>Choose "Add Sender To Address Book".</li> </ol> <p>To add our domain to your safe sender list:</p> <ol> <li>Right click on a non-displaying image in an HTML email.</li> <li>Choose "Add the domain to the safe sender list" option.</li> </ol>';        
        add_option('gsom_msg_confirmation_required',$msg); //confirmation-required
        
        $msg = '<h2>Thank You For Confirming Your Subscription To $blog_name!</h2>
        
<h3>A welcome e-mail is already on its way to you!</h3>

To make sure you get emails from $from_email, follow these simple guidelines:

Open your email program or log-in to your web email service.

<strong>Create a filter that will place our emails in your Inbox:</strong>

 <strong>From:</strong> field will always be $from_name
 <strong>Email address:</strong> $from_email

<strong>If our email is delivered to your Spam or Junk folder:</strong>

Click on the box in front of our email to insert a checkmark
Click the "This is not spam" button 

<strong>Add our email address to your Address Book or Friends List:</strong>

Open your Address Book or Friends List
Add our contact details as listed above
Click "Add" or "Save"';
        add_option('gsom_msg_confirmation_succeed',$msg); //confirmation successful.
        
$msg = '
The following record was removed from our online database and will also be removed from any backup files shortly.

Name: $gsom-fname-field
Email: $gsom-email-field

If you do receive further unwanted email from our system, please let us know using the contact information below and we\'d be happy to address the issue immediately.

$from_name
$from_email
$blog_url';
        
        add_option('gsom_msg_unsubscribe_succeed',$msg); //unsubscribe successful.        

        
        add_option('gsom_msg_bad_email_address','<h2>Please, enter a valid email address.</h2>'); //Bad email address
        
        $msg = 'This email is already subscribed and verified. If you are not receiving our newsletter, please check your spam filter settings as the email may have been incorrectly flagged as spam and moved to junk mail folder by your email client.

To make sure you get emails from $from_email, follow these simple guidelines:

Open your email program or log-in to your web email service.

<strong>Create a filter that will place our emails in your Inbox:</strong>

 <strong>From:</strong> field will always be $from_name
 <strong>Email address:</strong> $from_email

<strong>If our email is delivered to your Spam or Junk folder:</strong>

Click on the box in front of our email to insert a checkmark
Click the "This is not spam" button 

<strong>Add our email address to your Address Book or Friends List:</strong>

Open your Address Book or Friends List
Add our contact details as listed above
Click "Add" or "Save"';
        add_option('gsom_msg_email_subscribed_and_confirmed',$msg); //Email address already subscribed and confirmed.        

        $msg = 'This email address is already in our mailing list, however it has not been confirmed. If you would like your verification email resent, please <a href="$resend_confirmation_link">click here</a>.

To make sure you get emails from $from_email, follow these simple guidelines:

Open your email program or log-in to your web email service.

<strong>Create a filter that will place our emails in your Inbox:</strong>

 <strong>From:</strong> field will always be $from_name
 <strong>Email address:</strong> $from_email

<strong>If our email is delivered to your Spam or Junk folder:</strong>

Click on the box in front of our email to insert a checkmark
Click the "This is not spam" button 

<strong>Add our email address to your Address Book or Friends List:</strong>

Open your Address Book or Friends List
Add our contact details as listed above
Click "Add" or "Save"';        
        add_option('gsom_msg_email_subscribed_but_not_confirmed',$msg); //Email address already subscribed but not confirmed. Click here to resend confirmation email.

        $msg = 'You can change your subscription email <b>$decoded_email</b><p><form style="text-align: left;" method="POST" action=""><input type="hidden" name="gsom-x" value="$encoded_email"><label for="gsom-chsub-newemail">New Email:</label><input type="text" name="gsom-chsub-newemail" /><input type="submit" value="Change my email" name="gsom-chsub" /></form></p><p>You can unsubscribe from our mailing list:<form style="text-align: left;" action="/" method="post"><input type="hidden" name="gsom-x" value="$encoded_email"><input type="submit" value="Unsubscribe" name="gsom-unsubscribe" /></form></p>';
        add_option('gsom_msg_change_subscription',$msg); //Bad email address        
               

        add_option('gsom_sform_header', "<p>Fill out the form below and click the button...</p>");
        add_option('gsom_sform_footer', '<p style="font-size:x-small;">Our strict privacy policy keeps your email address 100% safe & secure.</p>');
        
        $gsom_predefined_form = '[{"label": "First Name:", "name": "gsom-fname-field", "value": "", "type": "text"}, {"label": "Last Name:", "name": "Last_Name1", "value": "", "type": "text"}, {"label": "Email:", "name": "gsom-email-field", "value": "", "type": "text"}, {"label": "", "name": "gsom-subscribe", "value": "Subscribe", "type": "submit"}]';
        add_option('gsom_def_form',$gsom_predefined_form);        
        add_option('gsom_form',$gsom_predefined_form);
    }
}

function gsom_options(){
    
    
    $gsom_def_form = get_option('gsom_def_form'); 
    if (isset($_REQUEST['submit']))
    {

       $gsom_form = gsom_mod_remslashes($_POST['gsom-json-serialized-form']);
       update_option('gsom_form',$gsom_form);
       
        $gsom_form_title = gsom_mod_remslashes($_POST['gsom_form_title']);        
        update_option('gsom_form_title',$gsom_form_title);


        $gsom_msg_confirmation_required = gsom_mod_remslashes($_POST['gsom_msg_confirmation_required']);
        update_option('gsom_msg_confirmation_required',$gsom_msg_confirmation_required);
        
        $gsom_msg_confirmation_succeed = gsom_mod_remslashes($_POST['gsom_msg_confirmation_succeed']);
        update_option('gsom_msg_confirmation_succeed',$gsom_msg_confirmation_succeed);
        
        $gsom_msg_unsubscribe_succeed = gsom_mod_remslashes($_POST['gsom_msg_unsubscribe_succeed']);
        update_option('gsom_msg_unsubscribe_succeed',$gsom_msg_unsubscribe_succeed);
                
        $gsom_msg_bad_email_address = gsom_mod_remslashes($_POST['gsom_msg_bad_email_address']);
        update_option('gsom_msg_bad_email_address', $gsom_msg_bad_email_address);
        
        $gsom_msg_email_subscribed_and_confirmed = gsom_mod_remslashes($_POST['gsom_msg_email_subscribed_and_confirmed']);
        update_option('gsom_msg_email_subscribed_and_confirmed', $gsom_msg_email_subscribed_and_confirmed);
        
        $gsom_msg_email_subscribed_but_not_confirmed = gsom_mod_remslashes($_POST['gsom_msg_email_subscribed_but_not_confirmed']);
        update_option('gsom_msg_email_subscribed_but_not_confirmed', $gsom_msg_email_subscribed_but_not_confirmed);
        

        $gsom_email_from = gsom_mod_remslashes($_POST['gsom_email_from']);        
        update_option('gsom_email_from',$gsom_email_from);
        
        $gsom_name_from = gsom_mod_remslashes($_POST['gsom_name_from']);        
        update_option('gsom_name_from',$gsom_name_from);
        
        $gsom_email_confirmation_subj = gsom_mod_remslashes($_POST['gsom_email_confirmation_subj']);
        update_option('gsom_email_confirmation_subj',$gsom_email_confirmation_subj);
        $gsom_email_confirmation_msg = gsom_mod_remslashes($_POST['gsom_email_confirmation_msg']);
        update_option('gsom_email_confirmation_msg',$gsom_email_confirmation_msg);
        
        $gsom_email_unsubscribe_subj = gsom_mod_remslashes($_POST['gsom_email_unsubscribe_subj']);
        update_option('gsom_email_unsubscribe_subj',$gsom_email_unsubscribe_subj);
        $gsom_email_unsubscribe_msg = gsom_mod_remslashes($_POST['gsom_email_unsubscribe_msg']);
        update_option('gsom_email_unsubscribe_msg',$gsom_email_unsubscribe_msg);
            
        $gsom_email_welcome_subj = gsom_mod_remslashes($_POST['gsom_email_welcome_subj']);
        update_option('gsom_email_welcome_subj',$gsom_email_welcome_subj);
        $gsom_email_welcome_msg = gsom_mod_remslashes($_POST['gsom_email_welcome_msg']);
        update_option('gsom_email_welcome_msg',$gsom_email_welcome_msg);
            
         if(!isset($_POST['gsom_send_welcome_message']))
            update_option('gsom_send_welcome_message','0');
         else
            {
                $gsom_send_welcome_message = gsom_mod_remslashes($_POST['gsom_send_welcome_message']);
                update_option('gsom_send_welcome_message',$gsom_send_welcome_message);
            }
            
         if(!isset($_POST['gsom_send_unsubscibed_message']))
            update_option('gsom_send_unsubscibed_message','0');
         else
         {
            $gsom_send_unsubscibed_message = gsom_mod_remslashes($_POST['gsom_send_unsubscibed_message']);
            update_option('gsom_send_unsubscibed_message',$gsom_send_unsubscibed_message);             
         }

        $gsom_sform_header = gsom_mod_remslashes($_POST['gsom_sform_header']);
        update_option('gsom_sform_header',$gsom_sform_header);
        $gsom_sform_footer = gsom_mod_remslashes($_POST['gsom_sform_footer']);    
        update_option('gsom_sform_footer',$gsom_sform_footer);

//        $gsom_send_welcome_message = gsom_mod_remslashes($_POST['gsom_send_welcome_message']);
//        update_option('gsom_send_welcome_message',$gsom_send_welcome_message);
//        $gsom_send_unsubscibed_message = gsom_mod_remslashes($_POST['gsom_send_unsubscibed_message']);       
//        update_option('gsom_send_unsubscibed_message',$gsom_send_unsubscibed_message);       
    }   
    else
    {
        $gsom_form = get_option('gsom_form');
        if (trim($gsom_form) == '')
            $gsom_form = $gsom_def_form;

        $gsom_msg_confirmation_required = get_option('gsom_msg_confirmation_required'); //confirmation-required        
        $gsom_msg_confirmation_succeed = get_option('gsom_msg_confirmation_succeed'); //confirmation successful.        
        $gsom_msg_unsubscribe_succeed = get_option('gsom_msg_unsubscribe_succeed'); // unsubscribe successfull
        $gsom_msg_bad_email_address = get_option('gsom_msg_bad_email_address'); //Bad email address        
        $gsom_msg_email_subscribed_and_confirmed = get_option('gsom_msg_email_subscribed_and_confirmed'); //Email address already subscribed and confirmed.        
        $gsom_msg_email_subscribed_but_not_confirmed = get_option('gsom_msg_email_subscribed_but_not_confirmed'); //Email address already subscribed but not confirmed. Click here to resend confirmation email.


            
        
        $gsom_form_title = get_option('gsom_form_title');
        
        
        
        $gsom_email_from = get_option('gsom_email_from');        
        $gsom_name_from = get_option('gsom_name_from');
        $gsom_email_confirmation_subj = get_option('gsom_email_confirmation_subj');
        $gsom_email_confirmation_msg = get_option('gsom_email_confirmation_msg');
            
        $gsom_email_welcome_subj = get_option('gsom_email_welcome_subj');
        $gsom_email_welcome_msg = get_option('gsom_email_welcome_msg');
        
        $gsom_email_unsubscribe_subj = get_option('gsom_email_unsubscribe_subj');
        $gsom_email_unsubscribe_msg = get_option('gsom_email_unsubscribe_msg');
            
        $gsom_send_welcome_message = get_option('gsom_send_welcome_message');
        $gsom_send_unsubscibed_message = get_option('gsom_send_unsubscibed_message');
        
        $gsom_sform_header = get_option('gsom_sform_header');
        $gsom_sform_footer = get_option('gsom_sform_footer');    
        
        $gsom_msg_change_subscription = get_option('gsom_msg_change_subscription');
        
        $gsom_send_welcome_message = get_option('gsom_send_welcome_message');
        $gsom_send_unsubscibed_message = get_option('gsom_send_unsubscibed_message');            
            
    }
    

?>
<!--[if IE]>
    <link type="text/css" rel="stylesheet" href="<?php echo get_bloginfo('wpurl');?>/wp-content/plugins/glsft-optin/css/gsom-ie.css" />    
<![endif]-->
<link type="text/css" rel="stylesheet" href="<?php echo get_bloginfo('wpurl');?>/wp-content/plugins/glsft-optin/css/gsom.css" />
<div class="wrap">
<h2>G-Lock Double Opt-in Manager</h2>
<?php
    if (isset($_REQUEST['submit']))
    {
?>
<p><div class="updated fade" id="message" style="background-color: #FFFBCC;"><p>Options <strong>updated</strong>.</p></div></p>
<?php
    }
?>        

<p>
If you find any bugs or have ideas for improvements or enhancements to functionality, please tell us. If possible, we will take your hints in consideration for future releases. If you have any questions or problems and want to get help from our support team or other users, please, visit <a target="_blank" href="http://www.justlan.com/forum/viewforum.php?f=24">G-Lock Software Community Forums</a>. We will be proud to help you. We will be happy if you could suggest WordPress Double Opt-In List Management Plugin from G-Lock Software to other people who could be interested in it, e. g. your friends, colleagues or maybe even your website visitors. Download free <a href="http://www.glockeasymail.com">email marketing software</a> to send your newsletter.
</p>
<form name="gsom_form" id="gsom_form" method="post" action="">
<p class="submit" style="border:none;">
<input type="submit" name="submit" value="Update Options &raquo;" />
</p>    
    <table class="form-table">
        <tr>
            <th scope="row">Email Settings</th>
            <td valign="middle" style="clear:both">
                <label style="float:left; line-height:22px; vertical-align:middle;" for="gsom_name_from">From Name:</label><input style="margin-left:5px;" type="text" size="40" name="gsom_name_from" value="<?php echo $gsom_name_from; ?>" /><br />
                <label style="float:left; line-height:22px; vertical-align:middle;" for="gsom_email_from">From Email:</label><input style="margin-left:5px;" type="text" size="40" name="gsom_email_from" value="<?php echo $gsom_email_from; ?>" /><br />
                <input style="float:left; margin-right:5px;" type="checkbox" name="gsom_send_welcome_message" value="1" <?php echo $gsom_send_welcome_message ? 'checked="checked"' : ''?> /><label style="float:left; line-height:22px; vertical-align:middle;" for="gsom_send_welcome_message">Send Welcome Message</label><br style="clear:both;" />
                <input style="float:left; margin-right:5px;" type="checkbox" name="gsom_send_unsubscibed_message" value="1" <?php echo $gsom_send_unsubscibed_message ? 'checked="checked"' : ''?> /><label style="float:left; line-height:22px; vertical-align:middle;" for="gsom_send_unsubscibed_message">Send Unsubscribe Notification</label>
            </td>
        </tr>
        <tr>
            <th>Submission Form</th>
            <td><p>Form Title:</p><textarea type="text" rows="5" cols="60" name="gsom_form_title"><?php echo $gsom_form_title; ?></textarea>
                <p>Form Header:</p><textarea type="text" rows="5" cols="60" name="gsom_sform_header"><?php echo $gsom_sform_header; ?></textarea>
                <p>Form Footer:</p><textarea type="text" rows="5" cols="60" name="gsom_sform_footer"><?php echo $gsom_sform_footer; ?></textarea><br />                
                <h3>Form Fields</h3>
                <div style="overflow:hidden;">
                    <div style="float:left; width:130px;">
                        <div style="display:block; float:none; overflow: hidden;"  id="gsom-ddbutton-placeholder"></div>
                        <div style="display:block; float:none; overflow: hidden;"  id="gsom-ddbutton-restore"></div>                        
                    </div>                
                    <div style="margin-left:130px;">
                        <ul id="gsom-fields-list">
                        </ul>
                    To re-order fields, drag a field up or down and drop it.                        
                    </div>
                    
                </div>
                <input type="hidden" id="gsom-json-serialized-form" name="gsom-json-serialized-form" value="" />
            </td>
        </tr>        
<!-- 
                            <li><label>Email:</label><input type="text" name="gsom-email-field" /></li>
                            <li><label>First Name:</label><input type="text" name="gsom-fname-field" /></li>
                            <li><div style="width:162px; float:right;"><input type="button" value="Subscribe"></div></li>                                                                        
-->        
        <tr>
            <th>Confirmation Email</th>
            <td>
                <div style="border-right:1px solid #C6D9E9; float: left; margin-right:5px; padding-right:5px;">
                    <p>Subject:</p><input type="text" size="60" name="gsom_email_confirmation_subj" value="<?php echo $gsom_email_confirmation_subj; ?>" />
                    <p>Message:</p>                    
                    <textarea type="text" rows="15" cols="60" name="gsom_email_confirmation_msg" ><?php echo $gsom_email_confirmation_msg; ?></textarea>
                    
                </div>
                <div style="float:left;">
                    <h3>Available variables:</h3>
                    <div id="gsom-confirm-mess-varlist">
                    </div>
                </div>
            </td>
        </tr>
        <tr>
            <th>Welcome Email</th>
            <td>
                <div style="float:left; border-right:1px solid #C6D9E9; margin-right:5px; padding-right:5px;">
                    <p>Subject:</p><input type="text" size="60" name="gsom_email_welcome_subj" value="<?php echo $gsom_email_welcome_subj; ?>" />
                    <p>Message:</p><textarea type="text" rows="10" cols="60" name="gsom_email_welcome_msg"><?php echo $gsom_email_welcome_msg; ?></textarea>
                </div>
                <div style="float:left; width: 300px;">
                    <h3>Important:</h3>
                    The way you welcome people lays the foundation of your future relationships. You won't have another chance to make the first impression on the subscriber so you have to get the most out of your welcome message. A skilful message creates a good reputation and defines you as serious email marketer.<br /><br /> In this article you'll find <nobr><a target="_blank" href="http://www.glockeasymail.com/9-tips-for-writing-a-welcome-message/">9 Tips for Writing Your Welcome Message</a></nobr>
                </div>
            </td>
        </tr> 
        <tr>
            <th>Unsubscribe Email</th>
            <td>
                <div style="float:left; border-right:1px solid #C6D9E9; margin-right:5px; padding-right:5px;">
                    <p>Subject:</p><input type="text" size="60" name="gsom_email_unsubscribe_subj" value="<?php echo $gsom_email_unsubscribe_subj; ?>" />
                    <p>Message:</p><textarea type="text" rows="10" cols="60" name="gsom_email_unsubscribe_msg"><?php echo $gsom_email_unsubscribe_msg; ?></textarea>
                </div>
                <div style="float:left; width: 300px;">
                    <h3>Important:</h3>
                    You can include an offer or promotion in the email confirming the unsubscribe action. This practice is hardly used by anyone in email marketing. When someone decided to unsubscribe from your list, often times, you can persuade them to get back on your list, you can direct them to a related resource that might be a better fit for them. Sometimes people can change their mind at the moment they are unsubscribing, so you'll just want to ask them to re-subscribe to get them back on your list.
                </div>
            </td>
        </tr>         
        <tr>
            <th>Action Pages</th>    
            <td><div>Wrong email address format:</div><textarea type="text" rows="10" cols="60" name="gsom_msg_bad_email_address"><?php echo $gsom_msg_bad_email_address;?></textarea>
                <div>Confirmation required:</div><textarea type="text" rows="10" cols="60" name="gsom_msg_confirmation_required"><?php echo $gsom_msg_confirmation_required;?></textarea>                
                <div>Confirmation successful (Thank you page):</div><textarea type="text" rows="10" cols="60" name="gsom_msg_confirmation_succeed"><?php echo $gsom_msg_confirmation_succeed;?></textarea>                                                
                <div>Email address is already subscribed and confirmed:</div><textarea type="text" rows="10" cols="60" name="gsom_msg_email_subscribed_and_confirmed"><?php echo $gsom_msg_email_subscribed_and_confirmed;?></textarea>
                <div>Email address is already subscribed but not confirmed:</div><textarea type="text" rows="10" cols="60" name="gsom_msg_email_subscribed_but_not_confirmed"><?php echo $gsom_msg_email_subscribed_but_not_confirmed;?></textarea>
                <div>Unsubscription successful:</div><textarea type="text" rows="10" cols="60" name="gsom_msg_unsubscribe_succeed"><?php echo $gsom_msg_unsubscribe_succeed;?></textarea>
            </td>            
        </tr>
    </table>    
<p class="submit">
<input type="submit" name="submit" value="Update Options &raquo;" />
</p>    
</form>
</div>
<script>    
   var gsomAdminMenu = true;
   var gsomPluginPath = '<?php echo get_bloginfo('wpurl').'/wp-content/plugins/glsft-optin/'; ?>';
   var form = <?php $s = (trim($gsom_form) != '') ? $gsom_form : $gsom_def_form; echo $s; ?>;   
   var def_form = <?php  $s = (trim($gsom_def_form) != '') ? $gsom_def_form : '[]'; echo $s;?>;
   init();
   BuildForm({arr:form});
   Sortable.create('gsom-fields-list',{onUpdate:SerializeForm, markDropZone:true, dropOnEmpty: true});   
</script>
<?php    
}

function gsom_mod_remslashes ( $string ){
    if (get_magic_quotes_gpc()==1) 
        return stripslashes( $string );    
    else 
        return ( $string );    
}

function gsom_manager()
{
    ?>

<link type="text/css" rel="stylesheet" href="<?php echo get_bloginfo('wpurl');?>/wp-content/plugins/glsft-optin/css/gsom.css" />    
<div class="wrap">
<div style="border-bottom: 1px solid #DADADA; overflow: hidden;">
    <h2 style="border:none; float: left; margin: 10px 0 0 0;">Manage Subscribers</h2>
    
    <div style="float:right; margin: 10px;">
        <button id="gsom-btn-export" class="button">Export to <img src="<?php echo get_bloginfo('wpurl');?>/wp-content/plugins/glsft-optin/img/darrow.gif"></button>
    </div>
    <div style="float:right; margin: 10px;">
        <label for="post-search-input">Email:</label>
            <input id="gsom-search-input" name="s" value="" type="text">
            <button class="button" id="gsom-search-btn">Search Subscribers</button>            
    </div>    
</div>

<div style="overflow:hidden;">

<ul class="subsubsub" style="float:left; margin-right: 50px;">
<li><a id="gsom-mgr-stype-all" class="gsom-flink current">All Subscribers</a> |</li>
<li><a id="gsom-mgr-stype-confirmed" class="gsom-flink">Confirmed</a> |</li>
<li><a id="gsom-mgr-stype-unconfirmed" class="gsom-flink">Unconfirmed</a> |</li>
<li><a id="gsom-mgr-stype-unsubscribed" class="gsom-flink">Unsubscribed</a></li>
</ul>
<button style="float:right; display:none;" class="button subsubsub" id="gsom-search-cancel-btn">Remove Search Filter</button>
</div>

<div class="tablenav">
    <div class="tablenav-pages">
    </div>
    <div class="alignleft">
        <button id="gsom-btn-unsubscribe" type="button" class="button-secondary">Unsubscribe</button>
        <button id="gsom-btn-delete" type="button" class="button-secondary">Delete</button>
    </div>

<br class="clear">
</div>

<br class="clear">


<table id="gsom-mgr-subscribers" class="widefat">
  <thead>
  <tr>
    <th scope="col" class="check-column"><input id="gsom-cbx-main" type="checkbox"></th>
    <th scope="col">Email</th>
    <th scope="col">Date</th>
    <th scope="col">IP Address</th>
    <th scope="col">Status</th>
    <th scope="col">Form Data</th>
  </tr>
  </thead>
  <tbody>
    <tr id="page-2" class="alternate">
         <th scope="row" class="check-column"><input name="delete[]" value="2" type="checkbox"></th>
         <td>Neocoder@gmail.com</td>
         <td><abbr title="2008/06/24 4:36:37 PM">2008/06/24</abbr></td>
         <td>127.0.0.1</td>
         <td><a href="http://blog.com/about/" title="View &quot;About&quot;" rel="permalink">Subscribed</a></td>        
         <td>gsom-fname-field : Alex<br />check_me2 : 1<br />Will_Big_Hadron_Collider_blow2 : Hell_yeah</td>
    </tr>

      </tbody>
</table>
<div class="tablenav">
    <div class="tablenav-pages">
    </div>
</div>

</div>

<script>
var pathToScripts = '<?php echo get_bloginfo('wpurl');?>/wp-content/plugins/glsft-optin/';
initManager();
</script>
    <?php    
}

function gsom_add_menu_item() {
    add_options_page('G-Lock Soft WP Opt-in Manager Options', 'G-Lock Double Opt-in Manager', 7, __FILE__, 'gsom_options' );
    add_submenu_page('edit.php', 'Manage Subscribers','Subscribers', 7, __FILE__, 'gsom_manager'); 
}

function gsom_init() {    
    global $wp;
    
    require_once('fakepage.php');    
    
    
    global $gsom_def_form;
    global $gsom_form;
    global $gsom_form_vars;
    
    if (trim($gsom_def_form)=='')
      $gsom_def_form = get_option('gsom_def_form');           
      
    if (trim($gsom_form) == '')
      $gsom_form = get_option('gsom_form');
      
    $jdform = json_decode($gsom_form,true);
    
    // if subscription form submitted
    $form_custom = '';
    
    if (isset($_REQUEST['gsom-resend-confirmation']))
    {
        $decEmail = gsom_ModBase64Decode($_REQUEST['gsom-resend-confirmation']);
        gsom_FillVarsWithCustomFormData($decEmail);        
        $gsom_email_confirmation_subj = get_option('gsom_email_confirmation_subj');
        $gsom_email_confirmation_msg = get_option('gsom_email_confirmation_msg');
        gsom_Mail($gsom_email_confirmation_subj,$gsom_email_confirmation_msg);
        wp_redirect( gsom_BuildLink('confirmation-required') );        
        echo " ";
        return;
    }
    
    if (isset($_REQUEST['gsom-chsub']))
    {        
        $decemail = gsom_ModBase64Decode($_POST['gsom-x']);        
        $newemail = strtolower($_POST['gsom-chsub-newemail']);
        if (gsom_changeEmail($decemail,$newemail))
        {            
            wp_redirect( gsom_BuildLink('subscription-changed') );        
            echo " ";
            return;                        
        }
    }
    
    if (isset($_REQUEST['gsom-unsubscribe']))
    {
        $decemail = gsom_ModBase64Decode($_POST['gsom-x']);        
        $xemail = $_POST['gsom-x'];
        if(gsom_unsubscribe($decemail))
        {
            gsom_FillVarsWithCustomFormData($decemail);
            
            $sendUnsubscribe = get_option('gsom_send_unsubscibed_message');
            if ($sendUnsubscribe == '1')
            {                        
                $gsom_email_unsubscribe_subj = get_option('gsom_email_unsubscribe_subj');
                $gsom_email_unsubscribe_msg = get_option('gsom_email_unsubscribe_msg');
                gsom_Mail($gsom_email_unsubscribe_subj,$gsom_email_unsubscribe_msg);            
            }
            
            wp_redirect( gsom_BuildLink('unsubscribe-successfull',array('x'=> $xemail)) );        
            echo " ";
            return;            
        }
    }
    
    if (isset($_POST['gsom-subscribe']))
    {
        $formSnapshot = array();
        $form_email = strtolower($_POST['gsom-email-field']);
        
        if (!gsom_EmailValid($form_email))
        {
            wp_redirect( gsom_BuildLink('bad-email') );        
            echo " ";
            return;            
        }
        
        foreach ($jdform as $item)
        {
            if (isset($_POST[$item['name']]))
            {
                if (($item['name'] != 'gsom-subscribe') && ($item['name'] != 'gsom-email-field'))
                {
                    $formSnapshot[] = array(
                        'name' => $item['name'],
                        'value' => $_POST[$item['name']],
                        'label' => $item['label']
                    );                    
                }   
                
                $gsom_form_vars[$item['name']] = $_POST[$item['name']];
            }
            else
            {
                $formSnapshot[] = array(
                    'name' => $item['name'],
                    'value' => '0',
                    'label' => $item['label']
                );
                $gsom_form_vars[$item['name']] = '0';
            }
            
        }
        
        $form_custom = json_encode($formSnapshot);
        
        $res = gsom_SubscriberPresent($form_email);
        
        if ($res === false) {
            if (gsom_AddSubscription($form_email,$form_custom)){
                $gsom_email_confirmation_subj = get_option('gsom_email_confirmation_subj');
                $gsom_email_confirmation_msg = get_option('gsom_email_confirmation_msg');                
                gsom_FillVarsWithCustomFormData($form_email);
                gsom_Mail($gsom_email_confirmation_subj,$gsom_email_confirmation_msg);
                wp_redirect( gsom_BuildLink('confirmation-required') );        
                echo " ";
                return;
            } 
        } 
        else
        {
            switch ($res)
            {
                case GSOM_SS_SUBSCRIBED:
                    // subscribed but not confirmed
                    wp_redirect( gsom_BuildLink('already-subscribed',array( 'x' => gsom_ModBase64Encode($form_email))));                    
                    echo " ";
                    return;                            
                break;                
                case GSOM_SS_CONFIRMED:
                    // subscribed and confirmed
                    wp_redirect( gsom_BuildLink('already-confirmed') );                    
                    echo " ";
                    return;                                                
                break;
                case GSOM_SS_UNSUBSCRIBED:
                    // unsubscribed
                    gsom_setUnconfirmed($form_email);
                    $gsom_email_confirmation_subj = get_option('gsom_email_confirmation_subj');
                    $gsom_email_confirmation_msg = get_option('gsom_email_confirmation_msg');                
                    gsom_FillVarsWithCustomFormData($form_email);
                    gsom_Mail($gsom_email_confirmation_subj,$gsom_email_confirmation_msg);
                    wp_redirect( gsom_BuildLink('confirmation-required') );        
                    echo " ";
                    return;
                break;
            }
        }              
    }              
    
    

    if (function_exists('wp_enqueue_script')) {
        wp_register_script('my-prototype', get_bloginfo('wpurl') . '/wp-content/plugins/glsft-optin/js/prototype.js', array(), '1.6.0.1');
        wp_enqueue_script('my-prototype');
        wp_register_script('my-scriptaculous', get_bloginfo('wpurl') . '/wp-content/plugins/glsft-optin/js/scriptaculous.js', array(), '1.8.1');
        wp_enqueue_script('my-scriptaculous');    
        wp_register_script('gsom', get_bloginfo('wpurl') . '/wp-content/plugins/glsft-optin/js/gsom.js', array(), '1.2');
        wp_enqueue_script('gsom');            
    }               

    gsom_plugin_loaded();
    
    if (stripos($_SERVER['REQUEST_URI'],'manage-subscription')!== false)
    {
        extract(gsom_RequestParamsPresent('x'));
        $msg = get_option('gsom_msg_change_subscription');
        $msg = gsom_replaceVars($msg);
        new FakePage('manage-subscription','Manage Subscription',$msg);
    }
    elseif (stripos($_SERVER['REQUEST_URI'],'confirmation-required')!== false)
    {        
        $msg = get_option('gsom_msg_confirmation_required');
        $msg = gsom_replaceVars($msg);
        new FakePage('confirmation-required','Confirmation Required',$msg);
    }
    elseif (stripos($_SERVER['REQUEST_URI'],'confirm-subscription')!== false)
    {
        extract(gsom_RequestParamsPresent('x'));
        $decEmail = gsom_ModBase64Decode($x);
        
        $present = gsom_SubscriberPresent($decEmail);
        
        if(($present !== false) && ($present == GSOM_SS_SUBSCRIBED))
        {
            if (gsom_ConfirmSubscription($decEmail))                
            {   
                gsom_FillVarsWithCustomFormData($decEmail);
                
                $sendWelcome = get_option('gsom_send_welcome_message');
                if ($sendWelcome == '1')
                {                                        
                    $gsom_email_welcome_subj = get_option('gsom_email_welcome_subj');            
                    $gsom_email_welcome_msg = get_option('gsom_email_welcome_msg');            
                    gsom_Mail($gsom_email_welcome_subj,$gsom_email_welcome_msg);                                    
                }
                
                $msg = get_option('gsom_msg_confirmation_succeed');
                $msg = gsom_replaceVars($msg);            
            }
            else        
            {
                wp_redirect( gsom_BuildLink('confirmation-failed') );
                echo " "; 
                return;           
            }                        
        } 
        else
        {            
            wp_redirect( gsom_BuildLink('confirmation-failed') );
            echo " "; 
            return;                       
        }
            
        new FakePage('confirm-subscription','Confirmation Successfull',$msg);        
    }
    elseif (stripos($_SERVER['REQUEST_URI'],'already-confirmed')!== false)
    {
        $msg = get_option('gsom_msg_email_subscribed_and_confirmed');        
        $msg = gsom_replaceVars($msg);
        new FakePage('already-confirmed','Already Confirmed',$msg);
    }
    elseif (stripos($_SERVER['REQUEST_URI'],'already-subscribed')!== false)
    {           
        $msg = get_option('gsom_msg_email_subscribed_but_not_confirmed');
        $msg = gsom_replaceVars($msg);
        new FakePage('already-subscribed','Already Subscribed',$msg);
    }
    elseif (stripos($_SERVER['REQUEST_URI'],'subscription-changed')!== false)
    {        
        new FakePage('subscription-changed','Subscription Changed','<h2>You subscription email was successfully changed.</h2>');
    }
    elseif (stripos($_SERVER['REQUEST_URI'],'unsubscribe-successfull')!== false)
    {
        //unsubscribe-successfull        
        $decEmail = gsom_ModBase64Decode($_REQUEST['x']);
        gsom_FillVarsWithCustomFormData($decEmail);
        $msg = get_option('gsom_msg_unsubscribe_succeed');
        $msg = gsom_replaceVars($msg);
        new FakePage('unsubscribe-successfull','Successfully Unsubscribed',$msg);        
    }
    elseif (stripos($_SERVER['REQUEST_URI'],'bad-email')!== false)
    {
        $msg = get_option('gsom_msg_bad_email_address');
        $msg = gsom_replaceVars($msg);
        new FakePage('bad-email','Bad Email Address',$msg);                        
    }
    elseif (stripos($_SERVER['REQUEST_URI'],'confirmation-failed')!== false)
    {        
        $msg = '<h3>Your email address was not found in our database.</h3>';
        new FakePage('confirmation-failed','Confirmation Failed',$msg);                        
    }
}

function gsom_RequestParamsPresent()
{    
    $array = array();
    $ret = array();
    
    for($i=0;$i < func_num_args(); $i++)    
        $array[] = func_get_arg($i);
    
    foreach ($array as $param)
    {
        if (!isset($_REQUEST[$param]))        
            $ret[$param] = '';        
        else        
            $ret[$param] = $_REQUEST[$param];        
    }
    return $ret;
}


function gsom_RequestPresent($param)
{
    if (!isset($_REQUEST[$param]))
    {
        if(func_num_args() == 2)
        {
            $def = func_get_arg(1);
            global ${$param};
            ${$param} = $def;
        }
        else
            ${$param} = '';
    }
    else
    {
        global ${$param};
        ${$param} = $_REQUEST[$param];
    }
}

function gsom_widget($args){
          extract($args);
          
    global $gsom_def_form;
    global $gsom_form;
    
    if (trim($gsom_def_form)=='')
      $gsom_def_form = get_option('gsom_def_form');           
      
    if (trim($gsom_form) == '')
      $gsom_form = get_option('gsom_form');
      
    $gsom_sform_header = get_option('gsom_sform_header');
    $gsom_sform_footer = get_option('gsom_sform_footer');          
  
  
  $gsom_form_title = get_option('gsom_form_title');
  if (trim($gsom_form) == '')
    $gsom_form = $gsom_def_form;          
      ?>
              <?php echo $before_widget; ?>
                  <?php echo $before_title
                      . $gsom_form_title
                      . $after_title . $gsom_sform_header ?>                  
                  <form name="gsom-optin" action="" method="post">
                  <div id="gsom-optin-form">                  
                  </div>                
                  </form>
                  <?php echo $gsom_sform_footer; ?>
                  <p style="font-size: x-small;">
<a href="http://www.glockeasymail.com/wordpress-email-newsletter-plugin-for-double-opt-in-subscription/">Create in-house opt-in list</a> with this widget. Download free <a href="http://www.glockeasymail.com">bulk email software</a> to send your newsletter.
              <?php echo $after_widget; ?>
<script>              
   var form = <?php $s = (trim($gsom_form) != '') ? $gsom_form : $gsom_def_form; echo $s; ?>;      
   BuildForm({makeDivs: true, arr:form, place:'gsom-optin-form'});    
</script>
      <?php    
}

function gsom_plugin_loaded(){    
    register_sidebar_widget('G-Lock Double Opt-in Manager', 'gsom_widget');        
}

function gsom_headMod(){
    echo '<link type="text/css" rel="stylesheet" href="' . get_bloginfo('wpurl') . '/wp-content/plugins/glsft-optin/css/gsom.css" />' . "\n";
}

function gsom_peerip() {
    if (isset($_SERVER)) 
    {
        if (isset($_SERVER["HTTP_X_FORWARDED_FOR"])) {
            $ip = $_SERVER["HTTP_X_FORWARDED_FOR"];
        } 
        elseif (isset($_SERVER["HTTP_CLIENT_IP"])) {
            $ip = $_SERVER["HTTP_CLIENT_IP"];
        } 
        else {
            $ip = $_SERVER["REMOTE_ADDR"];
        }
    } 
    else {
        if ( getenv( 'HTTP_X_FORWARDED_FOR' ) ) {
            $ip = getenv( 'HTTP_X_FORWARDED_FOR' );
        } 
        elseif ( getenv( 'HTTP_CLIENT_IP' ) ) {
            $ip = getenv( 'HTTP_CLIENT_IP' );
        } 
        else {
            $ip = getenv( 'REMOTE_ADDR' );
        }
    }
    return $ip;
}

function gsom_unsubscribe($email)
{
    global $wpdb;
    //global $gsom_table_subs;
    
    $gsom_table_subs = $wpdb->prefix . "gsom_subscribers";
    
    $sql = 'UPDATE '.$gsom_table_subs.' SET intStatus = '.GSOM_SS_UNSUBSCRIBED.' WHERE varEmail = %s';
    $result = $wpdb->query($wpdb->prepare($sql,$email));
    
    if ($result !== false)
        return true;
    else
        return false;  
}

function gsom_changeEmail($email,$newemail)
{
    global $wpdb;
    //global $gsom_table_subs;
    
    $gsom_table_subs = $wpdb->prefix . "gsom_subscribers";
    
    $sql = 'UPDATE '.$gsom_table_subs.' SET varEmail = %s WHERE varEmail = %s';
    $result = $wpdb->query($wpdb->prepare($sql,$newemail,$email));
    
    if ($result !== false)
        return true;
    else
        return false;  
}

function gsom_AddSubscription($email,$customData)
{
    global $wpdb;
    global $gsom_form_vars;
    //global $gsom_table_subs;
    $gsom_table_subs = $wpdb->prefix . "gsom_subscribers";
        $sql = 'INSERT INTO '.$gsom_table_subs.'(dtTime, varIP, varEmail, textCustomFields) VALUES(NOW(), %s, %s, %s)';
                
        $result = $wpdb->query($wpdb->prepare($sql,gsom_peerip(),$email,$customData));
        if ($result !== false)
        {
            $date = new DateTime();
            $df = get_option('date_format');
            $tf = get_option('time_format');                
            $gsom_form_vars['subscription_time'] = $date->format($df.' '.$tf);
            $gsom_form_vars['subscriber_ip'] = gsom_peerip();
            
            return true;
        }
        else
            return false;
}

function gsom_SubscriberPresent($email)
{
    global $wpdb;
    //global $gsom_table_subs;
    $gsom_table_subs = $wpdb->prefix . "gsom_subscribers";
    
    $sql = 'SELECT varEmail, intStatus FROM '.$gsom_table_subs.' WHERE varEmail = %s';
    $result = $wpdb->get_row($wpdb->prepare($sql,$email));
    if ($result)
    {
        return $result->intStatus;
    }
    else
        return false;
}

function gsom_ConfirmSubscription($email)
{
    global $wpdb;
    //global $gsom_table_subs;
    $gsom_table_subs = $wpdb->prefix . "gsom_subscribers";
    
    $sql = 'UPDATE '.$gsom_table_subs.' SET intStatus = '.GSOM_SS_CONFIRMED.' WHERE varEmail = %s';
    $result = $wpdb->query($wpdb->prepare($sql,$email));
    
    if ($result !== false)
        return true;
    else
        return false;    
}

function gsom_setUnconfirmed($email)
{
    global $wpdb;
    //global $gsom_table_subs;
    $gsom_table_subs = $wpdb->prefix . "gsom_subscribers";
    
    $sql = 'UPDATE '.$gsom_table_subs.' SET intStatus = '.GSOM_SS_SUBSCRIBED.' WHERE varEmail = %s';
    $result = $wpdb->query($wpdb->prepare($sql,$email));
    
    if ($result !== false)
        return true;
    else
        return false;    
}

function gsom_replaceVars($string)
{
    global $gsom_form_vars;    
    
    $tmpstr = $string;    
    foreach($gsom_form_vars as $key => $value)
    {        
       $tmpstr = preg_replace('/\$'.preg_quote($key).'/i', $value,$tmpstr);
    }
    return $tmpstr;
}

function gsom_replaceVar($string,$tpl,$replacement)
{
    return preg_replace('/\$'.$tpl.'/i', $replacement,$string);
}

function gsom_ModBase64Decode($str)
{
  $str = preg_replace('#\-#','/',$str);
  $str = preg_replace('#\_#','+',$str);
  return base64_decode($str.'==');
}

function gsom_ModBase64Encode($str)
{
  $str = Rtrim(base64_encode($str),'=');
  $str = preg_replace('#\/#','-',$str);
  $str = preg_replace('#\+#','_',$str);      
  return $str;
}

function gsom_GetUnsubscribeLink($email)
{
    $eemail = gsom_ModBase64Encode($email);
    return gsom_BuildLink('manage-subscription',array('x'=>$eemail));
}

function gsom_GetConfirmationLink($email)
{
    $eemail = gsom_ModBase64Encode($email);
    return gsom_BuildLink('confirm-subscription',array('x'=>$eemail));
}

function gsom_GetResendConfirmationLink($email)
{    
    $eemail = gsom_ModBase64Encode($email);    
    return get_bloginfo('wpurl').'/?gsom-resend-confirmation='.$eemail;
}

function gsom_FillVarsWithCustomFormData($email)
{
    global $wpdb;
    global $gsom_form_vars; 
    
    $gsom_table_subs = $wpdb->prefix . "gsom_subscribers";
    
    $sql = $wpdb->prepare('SELECT varEmail, textCustomFields, dtTime, varIP FROM '.$gsom_table_subs.' WHERE varEmail = %s',$email);    
    $result = $wpdb->get_row($sql);
    
    if ($result)
    {
        
        $gsom_form_vars['gsom-email-field'] = $email;
                     
        $date = new DateTime($result->dtTime);
        $df = get_option('date_format');
        $tf = get_option('time_format');                
        $gsom_form_vars['subscription_time'] = $date->format($df.' '.$tf);
        $gsom_form_vars['subscriber_ip'] = $result->varIP;
        
        $gsom_form_vars['manage_subscription_link'] = gsom_GetUnsubscribeLink($email);
        $gsom_form_vars['confirmation_link'] = gsom_GetConfirmationLink($email);
        $gsom_form_vars['resend_confirmation_link'] = gsom_GetResendConfirmationLink($email);    
        $gsom_form_vars['encoded_email'] = $email;
        $gsom_form_vars['decoded_email'] = gsom_ModBase64Encode($email);
        
        $customFields = $result->textCustomFields;
        
        $jdform = json_decode($customFields,true);       
       
        foreach($jdform as $item)
        {
            $gsom_form_vars[$item['name']] = $item['value'];
        }                
    }
    else
        return false;    
}

function gsom_BuildLink($page)
{
    $page = func_get_arg(0);
    
    if(func_num_args() == 2)    
        $params = func_get_arg(1);    
    else
        $params = array();
    
    $url = get_option('siteurl');
    if (trim(get_option('permalink_structure')) == '')
    {
        // permalinks disabeld add params
        $url .= '?page_id='.$page;
        foreach($params as $key => $value)
        {
            $url .= '&'.$key.'='.$value;
        }
    }
    else
    {
        // add permalink
        $url .= '/'.$page.'/';
        $ft = true;
        foreach($params as $key => $value)
        {
            if ($ft)
            {
                $del = '?';
                $ft = false;
            }
            else
                $del = '&';
            $url .= $del.$key.'='.$value;
        }        
    }    
    return $url;    
}

function gsom_EmailValid($email)
{
    return  preg_match("/\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*/", $email);
}


function gsom_Mail($subjTpl, $messageTpl)
{
    require_once('nomad_mimemail.inc.php');    
    
    global $gsom_form_vars;
    $email = $gsom_form_vars['gsom-email-field'];
    
    $subject = gsom_replaceVars($subjTpl);
    $body = gsom_replaceVars($messageTpl);
    
    
    $mimemail = new nomad_mimemail();
    $mimemail->charset = 'UTF-8';
    $mimemail->quoted_printable = true;    
    
    $gsom_email_from = $gsom_form_vars['from_email'];
    $gsom_name_from = $gsom_form_vars['from_name'];
    
    if(trim($body) == '' && trim($htmlbody) != '')                    
        $body = "This is an HTML message. Please use an HTML capable mail program to read this message.";                        
        
    $mimemail->set_from($gsom_email_from,$gsom_name_from);

//    if (!isset($this->toName))    
//        $mimemail->set_to($this->to);
//    else
//        $mimemail->set_to($this->to, $this->toName);
        
    $mimemail->set_to($email);
        
    $mimemail->set_subject($subject);
    $mimemail->set_text($body);    

    return $mimemail->send();    
}

register_activation_hook(__FILE__, 'gsom_install');
add_action('admin_menu', 'gsom_add_menu_item');
add_action('init', 'gsom_init');
add_action('wp_head', 'gsom_headMod');

?>
